setwd("C:/Users/ds821999/OneDrive - University of Reading/First year/Processing/S1/removeAvo")
library(dplyr)
library(ggplot2)
library(stringr)
library(gridExtra)
library(extrafont)

##to make res_stat see results_birds_3dims_inc_figure_3.R
res_stat=read.csv("res_stats_10_perc_0308.csv")

res_stat=res_stat[,2:ncol(res_stat)]
data= res_stat %>% filter(Method != "dis",
                          Missingness_col %in% c( "third")|Imputation_method=="cc")

grouped=data %>% filter(perc_10>=100)%>% 
  group_by(Imputation_method, Bias,Method) %>%
  summarise(Missingness_row=max(Missingness_row))

con=data %>% filter(Method=="con.hull",perc_10>=0)%>% 
  group_by(Imputation_method, Bias,Method) %>%
  summarise(Missingness_row=max(Missingness_row))
con=con %>% filter(Imputation_method=="cc" | Bias %in% c("r","h"))
con$Missingness_row=0
grouped=rbind(grouped,con)
grouped$Bias=factor(grouped$Bias, ordered=TRUE, levels=c("r", "l", "m", "h"))
grouped$Imputation_method=factor(grouped$Imputation_method, ordered=TRUE, levels=c("cc", "pf"))

con_twoth=grouped %>% filter(Method=="dis_cg")
con_twoth$Method="con.hull"
con_twoth$Missingness_row=0
grouped=rbind(grouped,con_twoth)
grouped$Bias=factor(grouped$Bias, ordered=TRUE, levels=c("r", "l", "m", "h"))
grouped$Imputation_method=factor(grouped$Imputation_method, ordered=TRUE, levels=c("cc", "pf"))

con.hull=grouped %>% arrange(desc(Missingness_row)) %>% 
  filter(Method=="con.hull") %>% 
  ggplot(aes(x=Bias,y=Missingness_row))+
  geom_bar(aes(fill=Imputation_method),stat='identity',position="dodge",
           col="black",width=0.9, lwd=0.2)+
  scale_fill_manual(values=c("#fd6b71","#fecece"), labels=c("complete case", "with imputation"))+
  theme_light()+
  theme(panel.spacing = unit(0, "lines"),
        strip.text=element_text(colour="black", size=10),
        strip.background=element_rect(fill="white"),
        panel.border=element_blank(),
        panel.grid.minor=element_blank(),
        panel.grid.major.y=element_line(colour="grey90"),
        panel.grid.major.x=element_blank(),
        plot.title=element_text(size=18, hjust=0.5),
        text=element_text(size=16,family="Leelawadee UI Semilight"),
        legend.position="none",
        axis.ticks.y=element_line(colour="grey90"),
        axis.ticks.x=element_blank(),
        axis.text=element_text(size=16),
        axis.ticks.length.y=unit(2, units="lines"),
        plot.margin = unit(c(1,-0.2,1,0),"lines"))+
  coord_cartesian(ylim=c(3.15,70))+
  scale_y_continuous(breaks=seq(from=0, to=70, by=10))+
  scale_x_discrete(labels=c("random", "low", "medium", "high"))+
  labs(title="Convex hull", y="Missingness permissible (%)", fill="")


dis=grouped %>% arrange(desc(Missingness_row)) %>% 
  filter(Method=="dis_cg") %>% 
  ggplot(aes(x=Bias,y=Missingness_row))+
  geom_bar(aes(fill=Imputation_method),stat='identity',position="dodge",
           col="black",width=0.9, lwd=0.2)+
  scale_fill_manual(values=c("#8bbfdb","#deebf7"), labels=c("complete case", "with imputation"))+
  theme_light()+
  theme(panel.spacing = unit(0, "lines"),
        strip.text=element_text(colour="black", size=10),
        strip.background=element_rect(fill="white"),
        panel.border=element_blank(),
        panel.grid.minor=element_blank(),
        panel.grid.major.y=element_line(colour="grey90"),
        panel.grid.major.x=element_blank(),
        plot.title=element_text(size=18, hjust=0.5),
        text=element_text(size=16,family="Leelawadee UI Semilight"),
        legend.position="none",
        plot.margin = unit(c(1,-0.2,1,0),"lines"),
        axis.text=element_text(size=16),
        axis.ticks.y=element_line(colour="grey90"),
        axis.ticks.x=element_blank())+
  coord_cartesian(ylim=c(3.15,70))+
  scale_y_continuous(breaks=seq(from=0, to=70, by=10))+
  scale_x_discrete(labels=c("random", "low", "medium", "high"))+
  labs(title="Distance-based Rao", y="Missingness permissible (%)",x="Bias", fill="")


tpd_ric=grouped %>% arrange(desc(Missingness_row)) %>% 
  filter(Method=="tpd_ric") %>% 
  ggplot(aes(x=Bias,y=Missingness_row))+
  geom_bar(aes(fill=Imputation_method),stat='identity',position="dodge",
           col="black",width=0.9, lwd=0.2)+
  scale_fill_manual(values=c("#90d289","#e5f5e0"), labels=c("complete case", "with imputation"))+
  theme_light()+
  theme(panel.spacing = unit(0, "lines"),
        strip.text=element_text(colour="black", size=10),
        strip.background=element_rect(fill="white"),
        panel.border=element_blank(),
        panel.grid.minor=element_blank(),
        panel.grid.major.y=element_line(colour="grey90"),
        panel.grid.major.x=element_blank(),
        plot.title=element_text(size=18, hjust=0.5),
        text=element_text(size=16,family="Leelawadee UI Semilight"),
        legend.position="none",
        axis.text.y=element_blank(),
        axis.text.x=element_text(size=16),
        axis.ticks.y=element_line(colour="grey90"),
        axis.ticks.x=element_blank(),
        axis.ticks.length.y=unit(2, units="lines"),
        plot.margin = unit(c(1,-0.2,1,-1),"lines"))+
  coord_cartesian(ylim=c(3.15,70))+
  scale_y_continuous(breaks=seq(from=0, to=70, by=10))+
  scale_x_discrete(labels=c("random", "low", "medium", "high"))+
  labs(title="TPD richness", y=" ",x="Bias", fill="")

tpd_div=grouped %>% arrange(desc(Missingness_row)) %>% 
  filter(Method=="tpd_div") %>% 
  ggplot(aes(x=Bias,y=Missingness_row))+
  geom_bar(aes(fill=Imputation_method),stat='identity',position="dodge",
           col="black",width=0.9, lwd=0.2)+
  scale_fill_manual(values=c("#fdae6b","#fee6ce"), labels=c("complete case", "with imputation"))+
  theme_light()+
  theme(panel.spacing = unit(0, "lines"),
        strip.text=element_text(colour="black", size=16),
        strip.background=element_rect(fill="white"),
        panel.border=element_blank(),
        panel.grid.minor=element_blank(),
        panel.grid.major.y=element_line(colour="grey90"),
        panel.grid.major.x=element_blank(),
        plot.title=element_text(size=18, hjust=0.5),
        text=element_text(size=16,family="Leelawadee UI Semilight"),
        legend.position="none",
        axis.text.y=element_blank(),
        axis.text.x=element_text(size=16),
        axis.ticks.y=element_line(colour="grey90"),
        axis.ticks.x=element_blank(),
        axis.ticks.length.y=unit(2, units="lines"),
        plot.margin = unit(c(1,-0.3,1,-1),"lines"))+
  coord_cartesian(ylim=c(3.15,70))+
  scale_y_continuous(breaks=seq(from=0, to=70, by=10))+
  scale_x_discrete(labels=c("random", "low", "medium", "high"))+
  labs(title="TPD divergence", y=" ",x="Bias", fill="")

plot=arrangeGrob(con.hull, tpd_ric, dis, tpd_div, ncol=2)

grid.arrange(con.hull, tpd_ric, dis, tpd_div, ncol=2)

